///////////////////////////////////////////////////////////////////////////////////////////
// $Header: /home/cvs/CVSROOT/Hausbeschallung/source/P89_1Wire/crc.c,v 1.2 2006/01/27 16:01:56 cvs Exp $
///////////////////////////////////////////////////////////////////////////////////////////


//--------------------------------
// Calculate a 8-Bit CRC
//
void crc8(unsigned char *crc, unsigned char b)
{
   unsigned char i;
   unsigned char temp;

   for (i = 8; i > 0; i--)
   {
      temp = ((*crc ^ b) & 0x01);
      if (temp == 0)
      {
         *crc >>= 1;
      }
      else
      {
         *crc ^= 0x18;
         *crc >>= 1;
         *crc |= 0x80;
      }
      b >>= 1;
   }
}


//--------------------------------
// Calculate a 16-Bit CRC
//
void crc16( unsigned int *crc, unsigned char d )
{
  int i;

  *crc ^= d;
  for( i = 8; i; i-- ){
    *crc = (*crc >> 1) ^ ((*crc & 1) ? 0xA001 : 0 );
  }
}
